#include <libnautilus-extension/nautilus-column-provider.h>

#include "nautilus-metadata-extractor.h"

void columns_provider_iface_init (NautilusColumnProviderIface *iface);
GList * get_metadata_columns (NautilusColumnProvider *provider);
static GType tpp_type = 0;

void columns_provider_iface_init (NautilusColumnProviderIface *iface)
{
	iface->get_columns = get_metadata_columns;
}

void metadata_columns_plugin_register_type(GTypeModule  *module)
{	
	const GTypeInfo info = {
		sizeof (GObjectClass),
		(GBaseInitFunc) NULL,
		(GBaseFinalizeFunc) NULL,
		(GClassInitFunc) NULL,
		NULL,
		NULL,
		sizeof (GObject),
		0,
		(GInstanceInitFunc) NULL
	};
	const GInterfaceInfo columns_provider_iface_info = {
		(GInterfaceInitFunc)columns_provider_iface_init,
		NULL,
		NULL
	};

	char* plugin_name = g_strdup_printf("%sColumns", get_extension_name());
	tpp_type = g_type_module_register_type (module, G_TYPE_OBJECT,
			plugin_name,
			&info, 0);
	g_type_module_add_interface (module,
			tpp_type,
			NAUTILUS_TYPE_COLUMN_PROVIDER,
			&columns_provider_iface_info);
	g_free(plugin_name);
}

void nautilus_module_initialize (GTypeModule  *module)
{
	metadata_columns_plugin_register_type(module);
}

void nautilus_module_shutdown   (void)
{
}

void nautilus_module_list_types (const GType **types, int *num_types)
{
	static GType type_list[1];

	type_list[0] = tpp_type;
	*types = type_list;
	*num_types = G_N_ELEMENTS (type_list);
}
