#include <libnautilus-extension/nautilus-column-provider.h>
#include <glib.h>
#include "nautilus-metadata-columns.h"
#include "nautilus-metadata-extractor.h"

GList * get_metadata_columns (NautilusColumnProvider *provider)
{
	initialize_extractor();
    GList *columns = NULL;
    NautilusColumn *column;

	GList* attributes_first_pointer = get_supported_attributes();
	NautilusAttributeDescriptor* attribute_descriptor;
	GList* attributes = attributes_first_pointer;
	while(attributes !=NULL)
    {
		attribute_descriptor = (NautilusAttributeDescriptor*) attributes->data;
        column = nautilus_column_new(
			attribute_descriptor->attribute,
			attribute_descriptor->attribute,
			attribute_descriptor->label,
			attribute_descriptor->description);
        columns = g_list_prepend(columns, column);
		
		attributes = g_list_next(attributes);
    }
	
	g_list_free(attributes_first_pointer);
	shutdown_extractor();
    
    return columns;
}

