
#include "nautilus-metadata-info.h"

#include <glib.h>
#include <stdlib.h>
#include "nautilus-metadata-dummy.h"
#include "nautilus-metadata-extractor.h"

static NautilusAttributeDescriptor extension_attributes[] =
{
	{ METADATA_DUMMY_ATTRIBUTE, "Dummy", "Dummy Description", "" },
	{ METADATA_DUMMY_ATTRIBUTE_2, "Dummy2", "Dummy2 Description", "" },
	{ METADATA_DUMMY_NOT_FILLED_ATTRIBUTE, "DummyNotFilled", "DummyNotFilled Description", "" },
};

GList* get_supported_attributes()
{
	GList* supported_attributes = NULL;
	
	int i;
	for (i=0; i<G_N_ELEMENTS(extension_attributes); i++)
	{
		supported_attributes = g_list_prepend(supported_attributes, extension_attributes + i);
	}
	
	return supported_attributes;
}

void extract_metadata_file(Metadata* metadata, const char* file_uri, const char* mime_type)
{
	g_warning("extracting %s", file_uri);
	metadata_set(metadata, METADATA_DUMMY_ATTRIBUTE, g_strdup("dummy"));
	metadata_set(metadata, METADATA_DUMMY_ATTRIBUTE_2, g_strdup("dummy_2"));
	
	GFile* file = g_file_new_for_uri(file_uri);
	char* path = g_file_get_path(file);
	g_object_unref(G_OBJECT(file));
	g_usleep(1000*1000*1);
	g_free(path);
}

void extract_metadata_directory(Metadata* metadata, const char* directory)
{
}

int get_max_thread_number()
{
	return 5;
}

void initialize_extractor()
{
	g_warning("initialize_extractor_dummy");
}

void shutdown_extractor()
{
	g_warning("shutdown_extractor_dummy");
}

const char* get_extension_name()
{
	return "NautilusMetadataExtensionDummy";
}