#include <libnautilus-extension/nautilus-info-provider.h>
#include "nautilus-metadata-info.h"
#include "nautilus-metadata-extractor.h"

NautilusOperationResult metadata_info_update_file_info(NautilusInfoProvider *provider, NautilusFileInfo *file, GClosure *update_complete, NautilusOperationHandle **handle);

static GType tpp_type = 0;

void metadata_info_cancel_update(NautilusInfoProvider  *provider, NautilusOperationHandle  *handle)
{
        UpdateHandle *update_handle = (UpdateHandle*)handle;     
        update_handle->cancelled = TRUE;
}

void metadata_info_provider_iface_init (NautilusInfoProviderIface *iface)
{
	iface->cancel_update = metadata_info_cancel_update;
	iface->update_file_info = metadata_info_update_file_info;
}

void metadata_info_plugin_register_type(GTypeModule  *module)
{	
	const GTypeInfo info = {
		sizeof (GObjectClass),
		(GBaseInitFunc) NULL,
		(GBaseFinalizeFunc) NULL,
		(GClassInitFunc) NULL,
		NULL,
		NULL,
		sizeof (GObject),
		0,
		(GInstanceInitFunc) NULL
	};
	const GInterfaceInfo metadata_info_provider_iface_info = {
		(GInterfaceInitFunc)metadata_info_provider_iface_init,
		NULL,
		NULL
	};

	char* plugin_name = g_strdup_printf("%sInfo", get_extension_name());
	tpp_type = g_type_module_register_type (module, G_TYPE_OBJECT,
			plugin_name,
			&info, 0);
	g_type_module_add_interface (module,
			tpp_type,
			NAUTILUS_TYPE_INFO_PROVIDER,
			&metadata_info_provider_iface_info);
	g_free(plugin_name);
}

void nautilus_module_initialize (GTypeModule  *module)
{    
	metadata_info_plugin_register_type(module);
	initialize();
}

void nautilus_module_shutdown   (void)
{
	shutdown();
}

void nautilus_module_list_types (const GType **types, int *num_types)
{
	static GType type_list[1];

	type_list[0] = tpp_type;
	*types = type_list;
	*num_types = G_N_ELEMENTS (type_list);
}