/* 
 * File:   nautilus-metadata-info.h
 * Author: yelo3
 *
 * Created on 13 luglio 2008, 2.00
 */

#ifndef _NAUTILUS_METADATA_INFO_H
#define	_NAUTILUS_METADATA_INFO_H

#ifdef	__cplusplus
extern "C" {
#endif

#include <libnautilus-extension/nautilus-info-provider.h>

#include "nautilus-metadata-attribute.h"

typedef struct {
	GClosure *update_complete;
	NautilusInfoProvider *provider;
	NautilusFileInfo *file;
	gboolean cancelled;
} UpdateHandle;

void initialize(void);
void shutdown(void);

typedef struct
{
//	GMutex* mutex;
	GData** gdata;
} Metadata;

typedef GDataForeachFunc MetadataForeachFunc;
Metadata* metadata_new();
void metadata_set(Metadata* metadata, const char* attribute_name, const char* attribute_value);
const char* metadata_get(Metadata* metadata, const char* attribute_name);
void metadata_foreach(Metadata* metadata, MetadataForeachFunc func, gpointer user_data);

#ifdef	__cplusplus
}
#endif

#endif	/* _NAUTILUS_METADATA_INFO_H */

